#!/usr/bin/perl

# modified squidguard script
# used with crontab for updating blacklists

require './squidguard-lib.pl';

# parse command line
if( @ARGV < 1 ) {
	print "usage: $0 dbhome [url]\n";
	exit(0);
}
my $dbhome = $ARGV[0];

if( $ARGV[1] ) {
	$url = $ARGV[1];
} else {
	$url = "http://ftp.ost.eltele.no/pub/www/proxy/squidGuard/contrib/blacklists.tar.gz";
}

print "$0 $dbhome $squiduid $squidgid $url\n";


  $file = &tempname();
  if ($url =~ /^http:\/\/([^\/]+)(\/.*)$/) {
    $host = $1; $page = $2; $port = 80;
    if ($host =~ /^(.*):(\d+)$/) { $host = $1; $port = $2; }
    &http_download($host, $port, $page, $file);
  } elsif ($in{'url'} =~ /^ftp:\/\/([^\/]+)\/(.*)$/) {
    $host = $1; $ffile = $2;
    &ftp_download($host, $ffile, $file);
  } else { &terror('gbl_invurl'); }

  # Uncompress the module file if needed
  open(MFILE, $file);
  read(MFILE, $two, 2);
  close(MFILE);

  if ($two eq "\037\235") {
    if (!&has_command("uncompress")) {
      unlink($file) if ($need_unlink);
      &terror('gbl_comp', "<tt>uncompress</tt>");
    }
  	local $temp = $file =~ /\/([^\/]+)\.Z/i ? "/tmp/$1" : &tempname();
  	local $out = `uncompress -c $file 2>&1 >$temp`;
  	unlink($file);
  	if ($?) {
		  unlink($temp);
  		&error('gbl_ecomp', $out);
  	}
  	$file = $temp;
  	$need_unlink = 1;
  } elsif ($two eq "\037\213") {
  	if (!&has_command("gunzip")) {
  		unlink($file) if ($need_unlink);
  		&terror('gbl_gzip', "<tt>gunzip</tt>");
  	}
  	local $temp = $file =~ /\/([^\/]+)\.gz/i ? "/tmp/$1" : &tempname();
  	local $out = `gunzip -c $file 2>&1 >$temp`;
  	unlink($file);
  	if ($?) {
  		unlink($temp);
  		&terror('gbl_egzip', $out);
  	}
  	$file = $temp;
  }

  $tar = `tar tf $file 2>&1`;
  if ($?) { &terror('gbl_tar', $tar); }

  my %blacklists=();
  my $blcount=0;
  foreach $f (split(/\n/, $tar)) {

    if ( ($f =~ /^\.\/blacklists\/([^\/]+)\/domains$/) ||
         ($f =~ /^blacklists\/([^\/]+)\/domains$/) ||
         ($f =~ /^\.\/blacklists\/([^\/]+)\/urls$/) ||
         ($f =~ /^blacklists\/([^\/]+)\/urls$/) ) {
      # we have a valid blacklist
      $blacklists{$1}++;
      $blcount++;
    }
  }

  if (! $blcount) {
    unlink($file);
    &terror('gbl_nolists');
  }

  # Extract blacklists
  $out = `cd $dbhome ; tar xf $file 2>&1 >/dev/null`;
  if ($?) {
    unlink($file);
    &terror('gbl_extract', $out);
  }
  unlink($file);

# system("chown -R $squiduid.$squidgid $dbhome/blacklists");

  for (keys %blacklists) {
    print "$_\n";
  }

